﻿// レイヤーをソートする
(function sortLayer(layObj){
    var nameList = [];  // 名前を入れる配列
    var lockList = [];  // ロック状態を入れる配列
    var visibleList = [];   // 表示状態を入れる配列
    for(var i=0; i<layObj.length; i++){
        layObj[i].name = "_"+layObj[i].name;
        // 名前とロック状態、可視状態を保存しておく
        nameList[i] = layObj[i].name;
        lockList[nameList[i]] = layObj[i].locked;
        layObj[i].locked = false;
        visibleList[nameList[i]] = layObj[i].visible;
        layObj[i].visible = true;
    }
    // レイヤーを昇順に並べ替え
    nameList = nameList.sort();
    var flag = confirm("降順にしますか？");
    if (flag == true){
        // レイヤー名を降順に並べ替える
        nameList.reverse();
    }
    // 挿入基準のレイヤーを一番上に移動する
    var baseLayObj = layObj[nameList[0]];
    baseLayObj.move(layObj[0], ElementPlacement.PLACEBEFORE);
    // レイヤーを並べ替え
    for(var i=1; i<nameList.length; i++){
        var aLay = layObj[nameList[i]];
        aLay.move(baseLayObj, ElementPlacement.PLACEBEFORE);
    }
    // 最初のレイヤーを移動
    baseLayObj.move(layObj[0], ElementPlacement.PLACEBEFORE);
    // 名前とロック状態、可視状態を元に戻す
    for(var i=0; i<layObj.length; i++){
        layObj[i].locked = lockList[nameList[i]];
        layObj[i].visible = visibleList[nameList[i]];
        layObj[i].name = layObj[i].name.substr(1, 99999);
    }
})(activeDocument.layers);
